//{$WARNINGS OFF}
//=============================================================================
//  ^Cgo[ɃRg[ǉEzuTv
//  Chris Rolliston񋟂̈ȉ̃R[h
//
//  ID: 27688, Custom Vista/Windows 7 title bar example
//  http://cc.embarcadero.com/item/27688
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  GPL 1.1
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0416 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  strict private
    FDwmBorderIconsRect: TRect;
    FOldIconChangeHandler: TNotifyEvent;
    FSysIconImageList: TImageList;
    FUseCustomFrame: Boolean;
    FWndFrameSize: Integer;
    FOriginGlassFrameTop : Integer;
    function GetSysIconRect: TRect;
    procedure IconChanged(Sender: TObject);
    procedure InvalidateCustomTitleBar;
    procedure RecalcGlassFrameBounds(UpdateFrame: Boolean = True);
  protected
    procedure AdjustClientRect(var Rect: TRect); override; //
    procedure Paint; override;
    procedure PaintWindow(DC: HDC); override;
    procedure Resize; override;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure WMNCRButtonUp(var Message: TWMNCRButtonUp); message WM_NCRBUTTONUP;
    procedure WMSetIcon(var Message: TWMSetIcon); message WM_SETICON;
    procedure WMWindowPosChanging(var Message: TWMWindowPosChanging);
      message WM_WINDOWPOSCHANGING;
    procedure WMWindowPosChanged(var Message: TWMWindowPosChanged);
      message WM_WINDOWPOSCHANGED;
    procedure WndProc(var Message: TMessage); override;
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

uses CommCtrl, DwmApi, UxTheme, App.DwmUtils;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  AdjustClientRect\bh
//  Rg[̎qRg[NCAg̈ɔzu鎞Ɏs
//  ł́CTFormGlassFrame̒lŐݒ肵NCAg̈ɍĐݒ
//  TFrameAlignalClientɂƁC̗̈Ɏ܂悤ɕ`悳
//-----------------------------------------------------------------------------
procedure TForm1.AdjustClientRect(var Rect: TRect);
begin
  inherited;
  if FUseCustomFrame then begin
    Inc(Rect.Top,     GlassFrame.Top);
    Inc(Rect.Left,    GlassFrame.Left);
    Inc(Rect.Right,  -GlassFrame.Right);
    Inc(Rect.Bottom, -GlassFrame.Bottom);
  end;
end;

//-----------------------------------------------------------------------------
//  Cm_TextChangebZ[W
//  R|[lg̃eLXg邢̓LvVύXꂽɁCgɑ
//  Ă郁bZ[W̏
//-----------------------------------------------------------------------------
procedure TForm1.CMTextChanged(var Message: TMessage);
begin
  inherited;
  InvalidateCustomTitleBar;
end;

//-----------------------------------------------------------------------------
//  tH[̃ACR̕`̈擾
//-----------------------------------------------------------------------------
function TForm1.GetSysIconRect: TRect;
begin
  if not (biSystemMenu in BorderIcons) or
     not (BorderStyle in [bsSingle, bsSizeable]) then begin
    SetRectEmpty(Result);
  end else begin
    Result.Left   := 0;
    Result.Right  := GetSystemMetrics(SM_CXSMICON);
    Result.Bottom := GetSystemMetrics(SM_CYSMICON);

    if WindowState = wsMaximized then begin
      if CheckWin32Version(6, 0) then begin
        Result.Top := GlassFrame.Top - Result.Bottom - 2;
      end else begin
        Result.Top := GlassFrame.Top - Result.Bottom - 4;
      end;
    end else begin
      if CheckWin32Version(6, 0) then begin
        Result.Top := 6;
      end else begin
        Result.Top := 8;
     end;
   end;

    Inc(Result.Bottom, Result.Top);
  end;
end;

//-----------------------------------------------------------------------------
//  IconOnChangedCxgnh
//  ݂TImageListjČIconOnChangedCxgnhs
//-----------------------------------------------------------------------------
procedure TForm1.IconChanged(Sender: TObject);
begin
  FreeAndNil(FSysIconImageList);
  FOldIconChangeHandler(Sender);
end;

//-----------------------------------------------------------------------------
//  Paint\bh
//  `悪KvɂȂƎs郁\bh
//
//  xTImageListɊi[āCTImageListɊi[ACR`悷
//  32rbg̉摜ƂTImageListɊi[C̉摜32rbgłȂꍇł
//  mɕ`ł
//-----------------------------------------------------------------------------
procedure TForm1.Paint;
var
  R : TRect;
begin
  if not FUseCustomFrame then begin
    inherited;
    exit;
  end;

  //ACR̕`̈擾ăACR`
  R := GetSysIconRect;
  if not IsRectEmpty(R) then begin

    //TImageList𐶐āCɃACR̉摜i[
    if FSysIconImageList = nil then begin
      FSysIconImageList := Create32BitImageList(Self,
                                                GetSystemMetrics(SM_CXSMICON),
                                                GetSystemMetrics(SM_CYSMICON),
                                                1);
      AddFormIconToImageList(Self, FSysIconImageList);
    end;

    //i[摜`
    R := GetSysIconRect;
    if WindowState = wsMaximized then begin
      R.Top := FWndFrameSize
    end;
    FSysIconImageList.Draw(Canvas, R.Left, R.Top, 0);
    R.Left := R.Right + FWndFrameSize - 3;
  end else begin
    R.Left := 0;
  end;

  //LvṼeLXg`
  R.Right  := FDwmBorderIconsRect.Left - FWndFrameSize - 1;
  R.Bottom := GlassFrame.Top;
  DrawGlassCaption(Self, R, True, taLeftJustify, tlTop);
  SelectClipRgn(Canvas.Handle, 0);

  inherited;
end;

//-----------------------------------------------------------------------------
//  PaintWindow\bh
//  JX^Rg[ WM_PAINT bZ[W󂯎ƎIɎs
//  NCAg̈Nbv
//-----------------------------------------------------------------------------
procedure TForm1.PaintWindow(DC: HDC);
var
  R : TRect;
begin
  if FUseCustomFrame then begin
    R := GetClientRect;
    with GlassFrame do begin
      ExcludeClipRect(DC, Left, Top, R.Right - Right, R.Bottom - Bottom);
    end;
  end;

  inherited;
end;

//-----------------------------------------------------------------------------
//  tH[ƃEBhËʒuύXɂȂɎs
//  -R.Top̓ftHgł30(^Cgo[̍)
//-----------------------------------------------------------------------------
procedure TForm1.RecalcGlassFrameBounds(UpdateFrame: Boolean = True);
var
  R : TRect;
begin
  SetRectEmpty(R);
  AdjustWindowRectEx(R,
                     GetWindowLong(Handle, GWL_STYLE),
                     False,
                     GetWindowLong(Handle, GWL_EXSTYLE));
  FWndFrameSize := R.Right;

  if FUseCustomFrame then begin
    GlassFrame.Top := FOriginGlassFrameTop - R.Top;
  end else begin
    GlassFrame.Top := 0;
  end;

  if UpdateFrame then
    SetWindowPos(Handle, 0, Left, Top, Width, Height, SWP_FRAMECHANGED);
end;

//-----------------------------------------------------------------------------
//  Resize\bh
//  TCY̍ۂɎs
//  VXẽACR(ŏ){^̍[̍Wl擾
//  LvV̕`ʒu̐ݒɎgp
//-----------------------------------------------------------------------------
procedure TForm1.Resize;
begin
  if FUseCustomFrame then FDwmBorderIconsRect := GetDwmBorderIconsRect(Self);
  inherited;
end;

//-----------------------------------------------------------------------------
//  WM_ACTIVATEbZ[W
//  ANeBuɂȂ^Cgo[ĕ`
//-----------------------------------------------------------------------------
procedure TForm1.WMActivate(var Message: TWMActivate);
begin
  inherited;
  InvalidateCustomTitleBar;
end;

//-----------------------------------------------------------------------------
//  WM_NCCALCSIZEbZ[W
//  NCAg̈̃TCYύXɁCNCAg̈ČvZ
//  GlassFramȅ㉺E̒l̕ύXɔ
//  FWndFrameSizẽftHgl8
//-----------------------------------------------------------------------------
procedure TForm1.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  if not FUseCustomFrame then begin
    inherited;
  end else begin
    with Message.CalcSize_Params.rgrc[0] do begin
      Inc(Left,   FWndFrameSize);
      Dec(Right,  FWndFrameSize);
      Dec(Bottom, FWndFrameSize);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_NCHITTESTbZ[W
//  }EẌړɂĔ郁bZ[W
//  ^Cgo[͕`悾Ȃ̂ŁĈ܂܂ł̓}EXCxg󂯕tȂ
//  ̃bZ[WŃ}EXʒuoāC̈ʒuɂĕKvȌʂԂ
//-----------------------------------------------------------------------------
procedure TForm1.WMNCHitTest(var Message: TWMNCHitTest);
var
  ClientPos : TPoint;
  IconRect  : TRect;
begin
  inherited;
  if not FUseCustomFrame then Exit;
  if not GlassFrame.Enabled then Exit;
  case Message.Result of
    HTCLIENT: ;
    HTMINBUTTON, HTMAXBUTTON, HTCLOSE:
    begin
      Message.Result := HTCAPTION;
      Exit;
    end;
  else exit;
  end;

  ClientPos := ScreenToClient(Point(Message.XPos, Message.YPos));
  if ClientPos.Y > GlassFrame.Top then Exit;

  //ID: 27688 ̃R[h́CControlAtPosȂ
  //ꂪȂƁCTGraphicControl̃NbNCxgołȂ
  if ControlAtPos(ClientPos, True) <> nil then Exit;

  IconRect := GetSysIconRect;
  if (ClientPos.X < IconRect.Right) and ((WindowState = wsMaximized) or
     ((ClientPos.Y >= IconRect.Top) and (ClientPos.Y < IconRect.Bottom)))
     then begin
    Message.Result := HTSYSMENU
  end else
  if ClientPos.Y < FWndFrameSize then begin
    Message.Result := HTTOP;
  end else begin
    Message.Result := HTCAPTION;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_NCRBUTTONUPbZ[W
//  j[ACRŃ}EXE{^UP̏
//-----------------------------------------------------------------------------
procedure TForm1.WMNCRButtonUp(var Message: TWMNCRButtonUp);
begin
  if not FUseCustomFrame or not (biSystemMenu in BorderIcons) then
    inherited
  else
    case Message.HitTest of
      HTCAPTION, HTSYSMENU: ShowSystemMenu(Self, Message);
    else inherited;
    end;
end;

//-----------------------------------------------------------------------------
//  WM_SETICONbZ[W
//-----------------------------------------------------------------------------
procedure TForm1.WMSetIcon(var Message: TWMSetIcon);
begin
  inherited;
  InvalidateCustomTitleBar;
end;

//-----------------------------------------------------------------------------
//  WM_WINDOWPOSCHANGINGbZ[W
//  EBhËʒuύX悤ƂĂ鎞̏
//  KXt[̃TCYČvZ
//-----------------------------------------------------------------------------
procedure TForm1.WMWindowPosChanging(var Message: TWMWindowPosChanging);
const
  SWP_STATECHANGED = $8000;
begin
  if FUseCustomFrame then begin
    if (Message.WindowPos.flags and SWP_STATECHANGED) = SWP_STATECHANGED then begin
      Invalidate;
    end;
  end else begin
    InvalidateCustomTitleBar;
  end;

  inherited;

  if (Message.WindowPos.flags and SWP_FRAMECHANGED <> 0) and FUseCustomFrame and
     (Message.WindowPos.flags <> SWP_FRAMECHANGED) then
    RecalcGlassFrameBounds(False);
end;

//-----------------------------------------------------------------------------
//  WM_WINDOWPOSCHANGEDbZ[W
//  EBhËʒuύXꂽs
//  ύX悤ƂĂ鎞ɍČvZlōĐݒ
//-----------------------------------------------------------------------------
procedure TForm1.WMWindowPosChanged(var Message: TWMWindowPosChanged);
begin
  inherited;
  if (Message.WindowPos.flags and SWP_FRAMECHANGED <> 0) and FUseCustomFrame then
    Realign;
end;

//-----------------------------------------------------------------------------
//  WndProc
//  ܂DWMɂ`悪łȂԂ̎͌WndProcs
//-----------------------------------------------------------------------------
procedure TForm1.WndProc(var Message: TMessage);
begin
  if not FUseCustomFrame or not HandleAllocated or
     not DwmDefWindowProc(Handle, Message.Msg, Message.WParam, Message.LParam,
                          Message.Result) then inherited;
end;

//-----------------------------------------------------------------------------
//  ^Cgo[̈̍ĕ`
//  LvV(^Cg)̕CACRCtH[̂TCY̎Ɏs
//-----------------------------------------------------------------------------
procedure TForm1.InvalidateCustomTitleBar;
var
  R : TRect;
begin
  if not HandleAllocated or not FUseCustomFrame then Exit;

  R.Left   := 0;
  R.Top    := 0;
  R.Right  := Width;
  R.Bottom := GlassFrame.Top;
  InvalidateRect(Handle, @R, False);
end;

//=============================================================================
//  ̃tH[OnCreateCxg
//=============================================================================
constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;

  FOriginGlassFrameTop := GlassFrame.Top;
  //AvIɃ[N̕񍐂
  ReportMemoryLeaksOnShutdown := True;
  //Rg[̃_uobt@̐ݒ
  EnableAppropriateDoubleBuffering(Self);

  //DWM(Desktop Window Manager)Lǂ𒲍
  //LȂ΃EBhEGlassFramẽTCYݒ
  FUseCustomFrame := DwmCompositionEnabled and Self.GlassFrame.Enabled;
  if FUseCustomFrame then begin
    RecalcGlassFrameBounds;
  end;

  //\TFrameɉ̎Ɏs邱ƂΎs
  //Frame11.Initialize(FUseCustomFrame);

  //ACRύXɂȂꍇlāCIconOnChangedCxg`
  FOldIconChangeHandler := Icon.OnChange;
  Icon.OnChange := IconChanged;

  //pl̏[̈ʒuݒ
  Panel1.Top := Panel1.Top + GlassFrame.Top;
end;


//-----------------------------------------------------------------------------
//  ͔̏ėpIŁCubN{bNXIɎgpł
//  (OnCreateCxǵCRg[̏Ɏgpꍇ)
//  ̉̃R[h́C̃tH[p̃R[h
//-----------------------------------------------------------------------------

{ TForm1 }

//=============================================================================
//  ̃tH[OnActivateCxg
//=============================================================================
procedure TForm1.FormActivate(Sender: TObject);
begin
  OnActivate := nil;
  if not DwmCompositionEnabled then
    MessageDlg('VXe Aero ( GA ) ɂȂĂ܂D',
               mtWarning, [mbOK], 0)
  else if FormsHaveCompatibilityCoords then
    MessageDlg('PE wb_̒l 6.0 ( Vista ) ȏɂĂ',
               mtWarning, [mbOK], 0)
end;

//=============================================================================
//  ǉ{^OnClickCxg
//=============================================================================
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Application.MessageBox('ǉ{^NbN', '');
end;

end.

